#include "wool/wool.h"

void wait(long nanosecs);

TASK_2( int, main, int, argc, char **, argv )
{

	CALL( psleep, 50, 100000000); //100ms

	return 0;
}

VOID_TASK_2( psleep, int, counter, long, nanosecs)
{

	if (counter > 0) {

		SPAWN( psleep, counter-1, nanosecs);
		wait(nanosecs);
		SYNC(psleep);
	}
}

void wait(long nanosecs) {
	hrtime_t timebefore = gethrtime();
	volatile int x = 0;
	while (gethrtime() - timebefore < nanosecs) {
		x |= x;
		x++;
	}
}

