#include "wool/wool.h"

void wait(long nanosecs);

TASK_2( int, main, int, argc, char **, argv )
{

	for (int i = 0; i < 100; i++) {
		SPAWN( psleep, 100000000); //100ms
	}

	for (int i = 0; i < 100; i++) {
		SYNC(psleep);
	}

	return 0;
}

VOID_TASK_1( psleep,long, nanosecs)
{
	wait(nanosecs);
}

void wait(long nanosecs) {
	hrtime_t timebefore = gethrtime();
	volatile int x = 0;
	while (gethrtime() - timebefore < nanosecs) {
		x |= x;
		x++;
	}
}
