package util;

import java.awt.Shape;
import java.math.BigDecimal;

public class Steal implements Comparable<Steal> {

	public final BigDecimal timeStamp;
	public final int thief, victim;
	public Shape shape;

	public Steal(BigDecimal timeStamp, int thief, int victim) {
		this.timeStamp = timeStamp;
		this.thief = thief;
		this.victim = victim;
	}

	@Override
	public int compareTo(Steal other) {
		return timeStamp.compareTo(other.timeStamp);
	}
}
